<template>
  <client-only>
    <div>
      <vl-map
        ref="map"
        class="map"
        :load-tiles-while-animating="true"
        :load-tiles-while-interacting="true"
        data-projection="EPSG:4326"
        @click="onClick"
        @mounted="mounted"
      >
        <vl-view :zoom.sync="zoom" :center.sync="center"></vl-view>

        <!-- base layer -->
        <vl-layer-tile
          v-for="layer in baseLayers"
          :id="layer.id"
          :key="layer.id"
          :visible="layer.visible"
        >
          <component :is="'vl-source-' + layer.name" v-bind="layer"></component>
        </vl-layer-tile>
        <!--// base layer -->

        <vl-interaction-select :features.sync="selectedFeatures">
          <template slot-scope="select">
            <!-- selected feature popup -->
            <vl-overlay
              v-for="feature in select.features"
              :id="feature.id"
              :key="feature.id"
              class="feature-popup"
              :position="pointOnSurface(feature.geometry)"
              :auto-pan="true"
              :auto-pan-animation="{ duration: 500 }"
            >
              <template class="offer-popup">
                <div class="offer-popup-hero">
                  <img
                    :src="buildImgUrl(feature.properties.offer.category)"
                    class="offer-popup-hero-image"
                  />
                  <h1 class="offer-popup-hero-title">
                    {{ feature.properties.offer.title }}
                  </h1>
                </div>
                <div class="offer-popup-profile">
                  <img
                    :src="buildImgUrl(feature.properties.offer.category)"
                    class="offer-popup-profile-picture"
                  />
                  <p class="offer-popup-profile-name">
                    <nuxt-link
                      :to="'users/' + feature.properties.offer.User.user_id"
                      >{{ feature.properties.offer.User.user_name }}</nuxt-link
                    >
                  </p>
                </div>
                <div class="offer-popup-body">
                  <p class="offer-popup-body-description">
                    {{ feature.properties.offer.description }}
                  </p>
                  <p class="offer-popup-body-datetime">
                    {{ feature.properties.offer.start_date }}
                  </p>
                </div>
                <div class="offer-popup-footer">
                  <nuxt-link
                    class="offer-popup-footer-more"
                    :to="'offers/' + feature.properties.offer.offer_id"
                  >
                    View More
                  </nuxt-link>
                </div>
              </template>
            </vl-overlay>
            <!--// selected feature popup -->
          </template>
        </vl-interaction-select>
        <!--// interactions -->

        <!-- geometries -->
        <vl-feature
          v-for="offer in offers"
          :id="offer.id"
          :key="offer.id"
          :properties="{
            offer: offer
          }"
        >
          <vl-geom-point
            v-if="offer.location.type == 'Point'"
            :coordinates="offer.location.coordinates"
          ></vl-geom-point>
          <vl-style-box>
            <vl-style-icon
              src="https://cdn4.iconfinder.com/data/icons/small-n-flat/24/map-marker-512.png"
              :anchor="[0.5, 1]"
              :scale="0.1"
            ></vl-style-icon>
            <vl-style-stroke color="green" :width="3"></vl-style-stroke>
          </vl-style-box>
          <vl-geom-line-string
            v-if="offer.location.type == 'LineString'"
            :coordinates="offer.location.coordinates"
          ></vl-geom-line-string>
        </vl-feature>
        <!--// geometries -->
        <vl-overlay
          v-show="showAddOfferOverlay"
          id="overlayAddOffer"
          class="overlayAddOffer"
          :position="overlayCoordinate"
          ><button-add-offer-overlay
            :coords="overlayCoordinate"
            @reloadData="mounted"
          ></button-add-offer-overlay>
        </vl-overlay>
      </vl-map>
      <!-- baselayer switch -->
      <ul class="baselayers-panel">
        <li
          v-for="layer in baseLayers"
          :key="layer.id"
          class="baselayers-panel-button"
          :class="{ 'is-info': layer.visible }"
          @click="showBaseLayer(layer.id)"
        >
          {{ layer.title }}
        </li>
      </ul>
      <!-- // baselayer switch -->

      <button-add-offer @reloadData="mounted" />
      <button-add-filter @applyFilter="filterData($event)" />

      <div class="geocode-container">
        <v-toolbar flat class="geocode-searchbar">
          <v-text-field
            v-model="SearchInput"
            dense
            hide-details
            outlined
            single-line
            clearable
          ></v-text-field>
          <v-btn-icon class="geocode-button" outline @click="Geocode">
            <v-icon>mdi-map-search</v-icon>
          </v-btn-icon>
        </v-toolbar>
        <div v-if="GeocodeResult" class="geocode-result">
          {{ GeocodeResult }}
        </div>
        <span v-if="GeocodeError" class="geocode-result">
          {{ GeocodeError }}
        </span>
      </div>
    </div>
  </client-only>
</template>

<script>
import { findPointOnSurface } from 'vuelayers/lib/ol-ext'
import { toLonLat } from 'ol/proj'
import ButtonAddOffer from '@/components/ButtonAddOffer'
import ButtonAddFilter from '@/components/ButtonAddFilter'
import ButtonAddOfferOverlay from '@/components/ButtonAddOfferOverlay'
import OffersService from '@/services/OffersService'
import OpenRouteService from '@/services/OpenRouteService'

const ORS = OpenRouteService

const methods = {
  pointOnSurface: findPointOnSurface,
  async mounted(check = false) {
    if (check === true) {
      this.offers = (await OffersService.filteredOffers(this.filter)).data
    } else {
      this.offers = (await OffersService.index()).data
    }
    const options = {
      day: 'numeric',
      weekday: 'long',
      month: 'long',
      year: 'numeric',
      hour: 'numeric',
      minute: 'numeric'
    }
    for (const i in this.offers) {
      const startDate = new Date(this.offers[i].start_date)
      const datetimeString = startDate.toLocaleString('en-US', options)
      this.offers[i].start_date = `${datetimeString}`
    }
    if (
      this.$colorMode.preference === 'system' ||
      this.$colorMode.preference === 'dark'
    ) {
      this.$vuetify.theme.dark = true
    } else {
      this.$vuetify.theme.dark = false
    }
  },
  async Geocode() {
    if (isNaN(parseInt(this.SearchInput))) {
      try {
        this.GeocodeError = undefined
        const response = await ORS.GeocodeSearch(this.SearchInput)
        const Feature = response.data.features[0]
        this.center = Feature.geometry.coordinates
        this.zoom = 15
        this.GeocodeResult = undefined
      } catch (error) {
        this.GeocodeResult = undefined
        this.GeocodeError = 'Please insert a string or click on the map!'
      }
    } else {
      try {
        this.GeocodeError = undefined
        const response = await ORS.GeocodeReverse(
          this.LonClicked,
          this.LatClicked
        )
        const Feature = response.data.features[0]
        this.GeocodeResult = `${Feature.properties.label}`
        this.center = [parseFloat(this.LonClicked), parseFloat(this.LatClicked)]
        this.SearchInput = undefined
      } catch (error) {
        this.GeocodeError = 'Could not find anything.'
      }
    }
  },

  showBaseLayer(id) {
    let layer = this.baseLayers.find((layer) => layer.visible)
    if (layer != null) {
      layer.visible = false
    }
    layer = this.baseLayers.find((layer) => layer.id === id)
    if (layer != null) {
      layer.visible = true
    }
  },

  onClick({ pixel }) {
    const coords = toLonLat(
      this.$refs.map.$map.getCoordinateFromPixel(pixel),
      this.projection
    )
    this.LonClicked = coords[0].toFixed(5)
    this.LatClicked = coords[1].toFixed(5)
    this.SearchInput = `${this.LonClicked}, ${this.LatClicked}`
    this.GeocodeResult = undefined
    this.GeocodeError = undefined

    this.showAddOfferOverlay = false
    this.overlayCoordinate = coords
    this.showAddOfferOverlay = true
  },

  filterData(filter) {
    this.filter = filter
    this.mounted(true)
  },

  buildImgUrl(name) {
    if (name) {
      return require(`@/static/img/${name}_01.jpg`)
    }
  }
}
export default {
  components: {
    ButtonAddOffer,
    ButtonAddFilter,
    ButtonAddOfferOverlay
  },
  data() {
    return {
      zoom: 13,
      center: [10.38, 53.8],
      projection: 'EPSG:3857',
      selectOnMap: false,
      SearchInput: undefined,
      SearchString: '',
      GeocodeResult: '',
      GeocodeError: '',
      LatClicked: null,
      LonClicked: null,
      selectedFeatures: [],
      showAddOfferOverlay: false,
      overlayCoordinate: [0, 0],
      offers: [],
      baseLayers: [
        {
          id: 0,
          name: 'osm',
          title: 'OpenStreetMap',
          visible: false
        },
        {
          id: 1,
          name: 'bingmaps',
          title: 'Bing Maps Dark',
          apiKey:
            'ArbsA9NX-AZmebC6VyXAnDqjXk6mo2wGCmeYM8EwyDaxKfQhUYyk0jtx6hX5fpMn',
          imagerySet: 'CanvasDark',
          visible: false
        },
        {
          id: 2,
          name: 'bingmaps',
          title: 'Bing Maps Grey',
          apiKey:
            'ArbsA9NX-AZmebC6VyXAnDqjXk6mo2wGCmeYM8EwyDaxKfQhUYyk0jtx6hX5fpMn',
          imagerySet: 'CanvasGray',
          visible: true
        },
        {
          id: 3,
          name: 'stamen',
          title: 'Stamen Toner',
          layer: 'toner',
          visible: false
        },
        {
          id: 4,
          name: 'xyz',
          title: 'Transport',
          url:
            'https://tile.thunderforest.com/transport-dark/{z}/{x}/{y}.png?apikey=8b5716aeca4b46778f61c9cad2ac6b92',
          visible: false
        }
      ]
    }
  },

  methods
}
</script>

<style>
* {
  margin: 0;
  box-sizing: border-box;
}

.ol-zoom button {
  color: var(--text-primary);
  position: relative;
  left: 4rem;
  top: 2rem;
  height: 3rem;
  width: 2rem;
  background: var(--bg-primary);
  border: var(--border);
}

.ol-zoom button:hover {
  background: var(--bg-secondary);
  color: var(--accent-light);
}

.ol-zoom .ol-zoom-out {
  box-shadow: var(--drop-shadow);
  border-radius: 0 0 var(--border-radius) var(--border-radius);
}
.ol-zoom .ol-zoom-in {
  box-shadow: var(--drop-shadow);
  border-radius: var(--border-radius) var(--border-radius) 0 0;
}

.ol-control button:focus {
  background-color: var(--bg-primary);
}

.ol-control {
  background: none;
}

.ol-control:hover {
  background: none;
}

.map {
  background: var(--bg-map);
  align-self: center;
  position: relative;
  margin-left: auto;
  margin-right: auto;
  width: calc(100vw - var(--width-sidebar));
  height: 100vh;
  display: block;
}

.button-clicked {
  font-size: 10pt;
  position: absolute;
  text-align: center;
  left: calc(42.5vw + (var(--width-sidebar) / 2));
  width: 15vw;
  margin: auto;
  padding-top: 2px;
  padding-bottom: 2px;
  bottom: 5.5rem;
  color: var(--text-primary);
  background-color: var(--bg-primary);
  border-radius: var(--border-radius);
  box-shadow: var(--drop-shadow);
}

.feature-popup {
  z-index: 2 !important;
  position: absolute;
  border-radius: var(--border-radius);
  border: var(--border);
  color: var(--text-primary);
  left: -50px;
  bottom: 12px;
  width: 50vw;
  max-width: 400px;
  background: var(--bg-primary);
}

.feature-popup::before,
.feature-popup::after {
  top: 100%;
  border: solid transparent;
  content: ' ';
  height: 0;
  width: 0;
  position: absolute;
  pointer-events: none;
}

.feature-popup::before {
  border-top-color: var(--bg-primary);
  border-width: 11px;
  left: 48px;
  margin-left: -11px;
}

.feature-popup::after {
  border-top-color: var(--bg-secondary);
  border-width: 10px;
  left: 48px;
  margin-left: -10px;
}

.overlayAddOffer {
  z-index: 1 !important;
  position: relative;
  border-radius: 10px 10px 10px 0px;
  border: var(--border);
  color: var(--text-primary);
  bottom: 35px;
  right: 0px;
  width: 2rem;
  height: 2rem;
  background: var(--bg-primary);
  cursor: pointer;
}

.offer-popup {
  border-radius: var(--border-radius);
}

.offer-popup-hero {
  border-radius: var(--border-radius) var(--border-radius) 0px 0px;
  text-align: center;
  height: 20vh;
  overflow: hidden;
}

.offer-popup-hero-image {
  width: 100%;
  height: 100%;
  background-size: cover;
  background-position: center;
  position: relative;
}

.offer-popup-hero-title {
  color: var(--text-primary);
  font-size: 2em;
  position: absolute;
  top: 25%;
  left: 50%;
  transform: translate(-50%, -50%);
}

.offer-popup-profile {
  height: 2em;
}

.offer-popup-profile-picture {
  width: 60px;
  height: 60px;
  border-radius: 50%;
  background-size: cover;
  background-position: center;
  border: 1px solid var(--accent-light);
  top: -30px;
  left: 10px;
  position: relative;
}

.offer-popup-profile-name {
  position: relative;
  top: -60px;
  left: 40px;
  font-size: 0.9em;
  padding-left: 2em;
}

.offer-popup-body-description {
  text-align: left;
  color: var(--text-secondary);
  padding-top: 10px;
  width: 90%;
  margin: 0 auto;
  padding-bottom: 1em;
}

.offer-popup-body-datetime {
  text-align: left;
  padding-top: 10px;
  width: 90%;
  margin: auto;
  bottom: 0.5em;
  position: relative;
  color: var(--text-primary);
}

.offer-popup-footer {
  background: var(--bg-secondary);
  border-radius: 0px 0px var(--border-radius) var(--border-radius);
  text-align: center;
  padding: 0.2rem;
}

.offer-popup-footer-more {
  text-decoration: none;
  font-size: 1em;
}

.baselayers-panel {
  display: flex;
  flex-direction: column;
  position: absolute;
  text-align: center;
  z-index: 1;
  right: 5rem;
  top: 2rem;
  animation: top-to-bot 1s ease-out;
  list-style: none;
}

.baselayers-panel-button {
  background-color: var(--bg-primary);
  color: var(--text-primary);
  border-radius: var(--border-radius);
  text-align: center;
  position: relative;
  padding: 0.5rem;
  margin: 2px;
  cursor: pointer;
  box-shadow: var(--drop-shadow);
  border: var(--border);
}

.baselayers-panel-button:hover {
  color: var(--accent-light);
  background: var(--bg-secondary);
}

.baselayers-panel-button:focus {
  outline: none;
  border: 2px solid var(--accent-light);
  border-radius: var(--border-radius);
}

.geocode-container {
  top: 2rem;
  width: 20rem;
  left: calc(40vw - var(--width-sidebar) / 2);
  position: absolute;
  color: var(--text-primary);
  background: var(--bg-primary);
  border: var(--border);
  border-radius: var(--border-radius);
}

.geocode-searchbar {
  background: var(--bg-primary) !important;
  color: var(--text-primary) !important;
  border-radius: var(--border-radius) !important;
}

.geocode-button {
  position: relative;
  left: 5px;
  cursor: pointer;
}

.geocode-result {
  position: relative;
  left: 15px;
  padding-bottom: 8px;
}
.overlay-content {
  z-index: 100;
}
@media only screen and (max-width: 813px) {
  .map {
    left: -5rem;
    margin-right: calc(0rem - var(--width-sidebar));
    width: 100vw;
  }
  .baselayers-panel {
    padding: 0;
    margin: 0;
    right: 0.5rem;
    top: 0.5rem;
    animation: none;
  }

  .button-clicked {
    width: 20vw;
    left: 42.5vw;
    bottom: calc(4.5vh + var(--height-sidebar));
  }
}
</style>
